<?php

declare(strict_types=1);

namespace App\Service\DrinkType;

use App\Entity\DrinkType;
use App\Entity\PropertyChangeLog;
use App\Repository\PropertyChangeLogRepository;

final readonly class GetWantedHistory
{
    public function __construct(private PropertyChangeLogRepository $propertyChangeLogRepository) {}
    /** @return PropertyChangeLog[] */
    public function __invoke(DrinkType $drinkType): array
    {
        if ($drinkType->getId() === null) {
            return[];
        }

        return $this->propertyChangeLogRepository->findBy([
            'entityClass' => DrinkType::class,
            'propertyName' => 'wantedStock',
            'entityId' => $drinkType->getId(),
        ]);
    }
}
